美文网首页
算法设计题目

算法设计题目

作者: 爱哭鬼丫头 | 来源:发表于2020-04-12 18:08 被阅读0次
    算法题目.jpg
    括号匹配问题

    假设表达式中运行包含两种括号:圆括号和方括号,其嵌套顺序随意。即()或者[([][])]都是正确的,而[(]或者([())都不是正确的格式,检验括号是否匹配的方法可用“期待的急迫程度”这个概念来描述,例如,考虑以下括号的判断[([][])],这种情况

    思路:

    1.将第0个元素压栈
    2.遍历[1,strlen(data)]

    • (1). 取栈顶字符
    • (2). 检查该字符是左括号("(","[")

    a.是左"(",则判断紧接其后的data[i]是为右")"
    YES->压栈,NO->出栈
    b.是左"[",则判断紧跟其后的data[i]是为右"]"
    YES->压栈,NO->出栈
    c.表示式如果以"#"结尾,则判断紧跟其后的data是为左"(""["
    YES->压栈,NO->-1;
    3.遍历结束,则判断栈是否为空,为空则表示匹配成功;否则匹配失败;

    //处理数据,借助栈判断
    /*
     思路:
     1. 将第0个元素压栈
     2. 遍历[1,strlen(data)]
        (3). 取栈顶字符
        (4). 检查该字符是左括号("(","[")
             a.是左"(",则判断紧接其后的data[i]是为右")"
                YES->压栈,NO->出栈
             b.是左"[",则判断紧跟其后的data[i]是为右"]"
                YES->压栈,NO->出栈
             c.表示式如果以"#"结尾,则判断紧跟其后的data是为左"(""["
                YES->压栈,NO->-1;
     
     3.遍历结束,则判断栈是否为空,为空则表示匹配成功;否则匹配失败;
     [ ( [ ] [ ] ) ]
     1 2 3 4 5 6 7 8
     */
    int ExecuteData(SqStack stack,char* data){
        Push(&stack, data[0]);
        for (int i = 1; i < strlen(data); i++) {
            char top = GetTop(stack);
            switch (top) {
                case '(':
                    if (data[i] == ')') {
                        Pop(&stack);
                    } else {
                        Push(&stack, data[i]);
                    }
                    break;
                case '[':
                    if (data[i] == ']') {
                        Pop(&stack);
                    } else {
                        Push(&stack, data[i]);
                    }
                    break;
                case '#':
                    if (data[i] == '(' || data[i] == '[') {
                        Push(&stack, data[i]);
                    }
                    break;
                default:
                    return -1;
                    break;
            }
        }
        if (stack.top == stack.base) {
            Destroy(&stack);
            return 0;
        } else {
            Destroy(&stack);
            return -1;
        }
        return 0;
    }
    
    每日温度

    根据每日气温列表,请重新生成一个列表,对应位置的输入是你需要等待多少天温度才会升高超过该日的天数,如果之后都不会升高,请在该位置0来替代,例如给定一个列表tem = [73,74,75,71,69,72,76,73],你的输出应该是[1,1,4,2,1,1,0,0],提示:气温列表长度的范围是[1,30000],每个气温的值均为华氏度,都是在[30,100]范围内的整数

    思路

    暴力法,遍历

    /*
     暴力法1:
     1. 从左到右开始遍历,从第一个数到最后一个数开始遍历. 最后一个数因为后面没有元素,默认是0,不需要计算;
     2. 从[i+1,TSize]遍历,每个数直到找到比它大的数,数的次数就是对应的值;
     
     思路:
     1.创建一个result 结果数组.
     2.默认reslut[TSize-1] = 0;
     3.从0个元素遍历到最后一个元素[0,TSize-1];
        A.如果当前i >0 并且当前的元素和上一个元素相等,则没有必要继续循环. 则判断一下result[i-1]是否等于0,如果等于则直接将result[i] = 0,否则将result[i] = result[i-1]-1;
        B.遍历元素[i+1,TSize]
            如果当前T[j]>T[i],则result[i] = j-i;
            如果当前T[j]已经是最后一个元素,则默认result[i] = 0;
     
     */
    int  *dailyTemperatures_1(int* T, int TSize, int* returnSize){
        
        int *result = (int *)malloc(sizeof(int) * TSize);
        *returnSize = TSize;
        result[TSize-1] = 0;
        
        for(int i = 0;i < TSize-1;i++)
            if(i>0 && T[i] == T[i-1])
                result[i] = result[i-1] == 0?0:result[i-1]-1;
            else{
                for (int j = i+1; j < TSize; j++) {
                    if(T[j] > T[i]){
                        result[i] = j-i;
                        break;
                    }
                    if (j == TSize-1) {
                        result[i] = 0;
                    }
                }
            }
        
        return result;
    }
    
    
    思路

    跳跃对比法

    /*
     跳跃对比:
     1. 从右到左遍历. 因为最后一天的气温不会再升高,默认等于0;
     2. i 从[TSize-2,0]; 从倒数第二天开始遍历比较. 每次减一;
     3. j 从[i+1,TSize]遍历, j+=result[j],可以利用已经有结果的位置进行跳跃,从而减少遍历次数
     -若T[i]<T[j],那么Result = j - i;
     -若reuslt[j] == 0,则表示后面不会有更大的值,那么当前值就应该也是0;
     
     思路:
     1.创建一个result 结果数组.
     2.默认reslut[TSize-1] = 0;
     3.从TSize-2个元素遍历到第一个元素[TSize-2,0];
     4.从[i+1,TSize]遍历,j+=result[j];
        -若T[i]<T[j],那么Result = j - i;
        -若reuslt[j] == 0,则表示后面不会有更大的值,那么当前值就应该也是0;
     
     */
    
    int  *dailyTemperatures_2(int* T, int TSize, int* returnSize){
        
        int *result = (int *)malloc(sizeof(int) * TSize);
        *returnSize = TSize;
        result[TSize-1] = 0;
        
        for (int i=TSize-2; i >= 0; i--) {
            for (int j = i+1; j < TSize; j+=result[j]) {
                if (T[i] < T[j]) {
                    result[i] = j-i;
                    break;
                }else
                {
                    if (result[j] == 0) {
                        result[i] = 0;
                        break;
                    }
                }
            }
        }
        
        return result;
    }
    
    思路

    栈思想

    /*
     思路:
     1. 初始化一个栈(用来存储索引),value数组
     2. 栈中存储的是元素的索引值index;
     3. 遍历整个温度数组从[0,TSize];
        (1).如果栈顶元素<当前元素,则将当前元素索引index-栈顶元素index,计算完毕则将当前栈顶元素移除,将当前元素索引index 存储到栈中; 出栈后,只要栈不为空.继续比较,直到栈顶元素不能满足T[i] > T[stack_index[top-1]]
     (2).如果当前的栈为空,则直接入栈;
     (3).如果当前的元素小于栈顶元素,则入栈
     (4).while循环结束后,当前元素也需要入栈;
     
     
    
     */
    int* dailyTemperatures_3(int* T, int TSize, int* returnSize) {
        
        int* result = (int*)malloc(sizeof(int)*TSize);
        // 用栈记录T的下标。
        int* stack_index = malloc(sizeof(int)*TSize);
        *returnSize = TSize;
        // 栈顶指针。
        int top = 0;
        int tIndex;
        
        for (int i = 0; i < TSize; i++)
            result[i] = 0;
        
        for (int i = 0; i < TSize; i++) {
            printf("\n循环第%d次,i = %d\n",i,i);
           
            // 若当前元素大于栈顶元素,栈顶元素出栈。即温度升高了,所求天数为两者下标的差值。
            while (top > 0 && T[i] > T[stack_index[top-1]]) {
                tIndex = stack_index[top-1];
                result[tIndex] = i - tIndex;
                top--;
                printf("tIndex = %d; result[%d] = %d, top = %d \n",tIndex,tIndex,result[tIndex],top);
            }
            
            // 当前元素入栈。
            stack_index[top] = i;
            printf("i= %d;  StackIndex[%d] = %d ",i,top,stack_index[top]);
            top++;
            
            printf(" top = %d \n",top);
        }
        
        return result;
    }
    
    八进制转换
    /*
     1. 初始化一个空栈S
     2. 当十进制N非零时,循环执行以下操作
        * 把N与8求余得到的八进制数压入栈S;
        * N更新为N与8的商;
     3. 当栈S非空时,循环执行以下操作
        * 弹出栈顶元素e;
        * 输出e;
     */
    void conversion(int N){
        
        SqStack S;
        SElemType e;
        //1.初始化一个空栈S
        InitStack(&S);
        
        //2.压栈
        while (N) {
            PushData(&S, N%8);
            N = N/8;
        }
        
        //3.出栈打印
        while (!StackEmpty(S)) {
            Pop(&S, &e);
            printf("%d\n",e);
        }
        
    }
    
    杨辉三角
    /*
     思路:
     1. 第一层循环控制行数i : 默认[i][0] = 1,[i][i] = 1
     2. 第二层循环控制列数j : triangle[i][j] = triangle[i-1][j-1] + triangle[i-1][j]
     */
    int** generate(int numRows, int* returnSize){
        
        *returnSize = numRows;
        
        int **res = (int **)malloc(sizeof(int*)*numRows);
        
        for (int i = 0; i < numRows; i++) {
            res[i] = (int *)malloc(sizeof(int)*(i+1));
            res[i][0] = 1;
            res[i][i] = 1;
            
            for (int j = 1; j < i; j++) {
                res[i][j] = res[i-1][j] + res[i-1][j-1];
            }
        }  
        return res;    
    }
    
    爬楼梯
    思路1

    递归的思路解决

    /*
     方法一:递归求解法
     f(n) = f(n-1) + f(n-2);
     f(1)=1;
     f(2)=1;
     */
    int ClimbStairs_1(int n){
        
        if (n<1)  return 0;
        if (n == 1) return 1;
        if (n == 2) return 2;
        
        return ClimbStairs_1(n-1) + ClimbStairs_1(n-2);
    }
    
    
    思路2

    动态规划的思路

    /*
     方法二:动态规划法
     */
    int ClimbStairs(int n){
        if(n==1) return 1;
        int temp = n+1;
        int *sum = (int *)malloc(sizeof(int) * (temp));
        sum[0] = 0;
        sum[1] = 1;
        sum[2] = 2;
        
        for (int i = 3; i <= n; i++) {
            sum[i] = sum[i-1] + sum[i-2];
        }
        
        return sum[n];
    }
    
    字符串编码

    题目: 字符串编码LeetCode-中等
    编码规则为: k[encoded_string],表示其中方括号内部的 encoded_string 正好重复 k 次。注意 k 保证为正整数。你可以认为输入字符串总是有效的;输入字符串中没有额外的空格,且输入的方括号总是符合格式要求的。此外,你可以认为原始数据不包含数字,所有的数字只表示重复的次数 k ,例如不会出现像 3a 或 2[4] 的输入。
    例如:
    s = "3[a]2[bc]", 返回 "aaabcbc".z

    s = "3[a2[c]]", 返回 "accaccacc".
    s = "2[abc]3[cd]ef", 返回 "abcabccdcdcdef".

    /*
     思路:
     例如:12[a]为例;
     
     1.遍历字符串 S
     2.如果当前字符不为方括号"]" 则入栈stack中;
     2.如果当前字符遇到了方括号"]" 则:
     ① 首先找到要复制的字符,例如stack="12[a",那么我要首先获取字符a;将这个a保存在另外一个栈去tempStack;
     ② 接下来,要找到需要备份的数量,例如stack="12[a",因为出栈过字符"a",则当前的top指向了"[",也就是等于2;
     ③ 而12对于字符串是2个字符, 我们要通过遍历找到数字12的top上限/下限的位置索引, 此时上限curTop = 2, 下限通过出栈,top = -1;
     ④ 根据范围[-1,2],读取出12保存到strOfInt 字符串中来, 并且将字符"12\0",转化成数字12;
     ⑤ 当前top=-1,将tempStack中的字符a,复制12份入栈到stack中来;
     ⑥ 为当前的stack扩容, 在stack字符的末尾添加字符结束符合'\0';
     
     */
    
    char * decodeString(char * s){
       
        /*.
         1.获取字符串长度
         2.设置默认栈长度50
         3.开辟字符串栈(空间为50)
         4.设置栈头指针top = -1;
         */
        int len = (int)strlen(s);
        int stackSize = 50;
        char* stack = (char*)malloc(stackSize * sizeof(char));
        int top = -1;
        
        //遍历字符串,在没有遇到"]" 之前全部入栈
        for (int i = 0; i < len; ++i) {
            if (s[i] != ']') {
                //优化:如果top到达了栈的上限,则为栈扩容;
                if (top == stackSize - 1) {
                    stack = realloc(stack, (stackSize += 50) * sizeof(char));
                }
                //将字符入栈stack
                stack[++top] = s[i];
                printf("#① 没有遇到']'之前# top = %d\n",top);
            }
            else {
                int tempSize = 10;
                char* temp = (char*)malloc(tempSize * sizeof(char));
                int topOfTemp = -1;
                
                printf("#② 开始获取要复制的字符信息之前 # top = %d\n",top);
                //从栈顶位置开始遍历stack,直到"["结束;
                //把[a]这个字母a 赋值到temp栈中来;
                //简单说,就是将stack中方括号里的字符出栈,复制到temp栈中来;
                while (stack[top] != '[') {
                    
                    //优化:如果topOfTemp到达了栈的上限,则为栈扩容;
                    if (topOfTemp == tempSize - 1) {
                        temp = realloc(temp, (tempSize += 10) * sizeof(char));
                    }
                    //temp栈的栈顶指针自增;
                    ++topOfTemp;
                    //将stack栈顶字符复制到temp栈中来;
                    temp[topOfTemp] = stack[top];
                    //stack出栈,则top栈顶指针递减;
                    top--;
                }
                printf("#② 开始获取要复制的字符信息之后 # top = %d\n",top);
                
                //找到倍数数字.strOfInt字符串;
                //注意:如果是大于1位的情况就处理
                char strOfInt[11];
                //p记录当前的top;
                int curTop = top;
                printf("#③ 开始获取数字,数字位置上限 # curTop = %d\n",curTop);
                
                //top--的目的是把"["剔除,才能找到数字;
                top--;
                //遍历stack得出数字
                //例如39[a] 就要找到这个数字39.
                //p指向当前的top,我就知道上限了; 那么接下来通过循环来找它的数字下限;
                //结束条件:栈指针指向为空! stack[top] 不等于数字
                while (top != -1 && stack[top] >= '0' && stack[top] <= '9') {
                    top--;
                }
                printf("#③ 开始获取数字,数字位置下限 # top = %d\n",top);
                
                //从top-1遍历到p之间, 把stack[top-1,p]之间的数字复制到strOfInt中来;
                //39中3和9都是字符. 我们要获取到这2个数字,存储到strOfInt数组
                for (int j = top + 1; j < curTop; ++j) {
                    strOfInt[j - (top + 1)] = stack[j];
                }
                //为字符串strOfInt数组加一个字符结束后缀'\0'
                strOfInt[curTop - (top + 1)] = '\0';
                
                //把strOfInt字符串转换成整数 atoi函数;
                //把字母复制strOfInt份到stack中去;
                //例如39[a],就需要把复制39份a进去;
                int curNum = atoi(strOfInt);
                for (int k = 0; k < curNum ; ++k) {
                    
                    //从-1到topOfTemp 范围内,复制curNum份到stackTop中去;
                    int kk = topOfTemp;
                    while (kk != -1) {
                        
                        //优化:如果stack到达了栈的上限,则为栈扩容;
                        if (top == stackSize - 1) {
                            stack = realloc(stack, (stackSize += 50) * sizeof(char));
                        }
                        
                        //将temp栈的字符复制到stack中;
                        //stack[++top] = temp[kk--];
                        ++top;
                        stack[top] = temp[kk];
                        kk--;
                        
                    }
                }
                free(temp);
                temp = NULL;
            }
        }
        
        //realloc 动态内存调整;
        //void *realloc(void *mem_address, unsigned int newsize);
        //构成字符串stack后, 在stack的空间扩容.
        char* ans = realloc(stack, (top + 1) * sizeof(char));
        ans[++top] = '\0';
        
        //stack 栈不用,则释放;
        free(stack);
        return ans;
    }
    

    相关文章

      网友评论

          本文标题:算法设计题目

          本文链接:https://www.haomeiwen.com/subject/tuebmhtx.html